UNIT Mouse;

INTERFACE

PROCEDURE ShowMouse;
PROCEDURE HideMouse;
PROCEDURE GetMouse(VAR MouseX, MouseY : Word; VAR MouseB : Byte);
PROCEDURE SetMouse(Mousex, MouseY : Word);
FUNCTION  GetTicks : LongInt;
FUNCTION  IsDoubleClick(Mx, My : Word) : Boolean;

IMPLEMENTATION

CONST
     DBL_CLICK_SPEED = 6;

VAR
   LastClick : LongInt;
   LastX, LastY : Word;

PROCEDURE ShowMouse; Assembler;
ASM
   Mov Ax, $0001
   Int $33
End;

PROCEDURE HideMouse; Assembler;
ASM
   Mov Ax, $0000
   Int $33
End;

PROCEDURE GetMouse(VAR MouseX, MouseY : Word; VAR MouseB : Byte); Assembler;
ASM
   Mov Ax, $0003
   Int $33
   Shr Cx, 1
   Les Di, MouseX          { ES:DI = @MouseX }
   Mov Es:[Di], Cx
   Les Di, MouseY          { ES:DI = @MouseY }
   Mov Es:[Di], Dx
   Les Di, MouseB          { ES:DI = @MouseY }
   Mov Es:[Di], Bl
End;

PROCEDURE SetMouse(MouseX, MouseY : Word); Assembler;
ASM
   Mov Ax, $0004
   Mov Cx, MouseX
   Mov Dx, MouseX
   Shl Cx, 1
   Int $33
End;

FUNCTION GetTicks : LongInt;
VAR A : Byte;
    B, C : Word;
Begin
ASM
   Mov Ah, $00
   Int $1A
   Mov A, Al
   Mov B, Cx
   Mov C, Dx
End;
    GetTicks := A Shl 16 + B shl 8 + C;
End;

FUNCTION IsDoubleClick(Mx, My : Word) : Boolean;
Begin
     If (GetTicks-LastClick < DBL_CLICK_SPEED) AND
        (LastX = Mx) AND (LastY = My) Then IsDoubleClick := True
     ELSE IsDoubleClick := False;

     LastClick := GetTicks; LastX := Mx; LastY := My;
End;

Begin
End.